%% beamerKIT.cls: LaTeX class for KIT presentations
%% ====================================================
%% Author: Dr. Thomas Hertweck, Thomas.Hertweck@kit.edu
%% ====================================================

\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{beamerKIT}[2025/03/03 v2.0 KIT presentation template]

\RequirePackage{xkeyval}
\RequirePackage{kvoptions}
\RequirePackage{xifthen}
%\RequirePackage{xprintlen}            % debug only
%\RequirePackage{layout}               % debug only
\RequirePackage[l2tabu,orthodox]{nag}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% class options and checks %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\SetupKeyvalOptions{
  family = KIT,
  prefix = kit@
}

\DeclareStringOption[169]{aspectratio}
\DeclareBoolOption[true]{english}
\DeclareComplementaryOption{german}{english}
\DeclareBoolOption[false]{plain}
\DeclareStringOption[none]{license}
\DeclareBoolOption[false]{progressbar}
\DeclareBoolOption[false]{showtotal}
\DeclareBoolOption[false]{footlic}
\DeclareBoolOption[false]{largefont}
\DeclareBoolOption[false]{grid}
\DeclareStringOption[kit]{design}
\DeclareStringOption[iceblue]{colorscheme}
\DeclareDefaultOption{%
  \ClassError{beamerKIT}%
             {Unknown class option encountered: \CurrentOption}%
             {Remove class option and/or check spelling}
}

\ProcessKeyvalOptions{KIT}

\ifthenelse{\equal{\kit@aspectratio}{169} \OR%
            \equal{\kit@aspectratio}{1610} \OR%
            \equal{\kit@aspectratio}{43}}{}{%
  \ClassError{beamerKIT}%
             {Unknown aspectratio option}%
             {Available aspectratio options: 169 (default), 1610, 43}%
}

\ifthenelse{\equal{\kit@license}{none} \OR%
            \equal{\kit@license}{ccby} \OR%
            \equal{\kit@license}{ccbysa} \OR%
            \equal{\kit@license}{ccbynd} \OR%
            \equal{\kit@license}{ccbync} \OR% 
            \equal{\kit@license}{ccbyncsa} \OR%
            \equal{\kit@license}{ccbyncnd}}{}{%
            \ClassError{beamerKIT}%
                       {Unknown license option}%
                       {Available options: none (default), ccby, ccbysa, ccbynd, ccbync, ccbyncsa, ccbyncnd}
}

\ifthenelse{\equal{\kit@design}{kit} \OR \equal{\kit@design}{gpi}}{}{%
  \ClassError{beamerKIT}%
             {Unknown design option}%
             {Available design options: kit (default), gpi}
}

\ifthenelse{\equal{\kit@colorscheme}{iceblue} \OR \equal{\kit@colorscheme}{white}}{}{%
  \ClassError{beamerKIT}%
             {Unknown colorscheme option}%
             {Available design options: iceblue (default), white}
}

\newcommand{\kit@beamer@fontsize}{8pt}
\ifkit@largefont%
\renewcommand{\kit@beamer@fontsize}{10pt}
\fi

\newboolean{kit@strict}
\setboolean{kit@strict}{true}
\ifthenelse{\equal{\kit@design}{gpi}}{\setboolean{kit@strict}{false}}{}

\newboolean{kit@iceblue}
\setboolean{kit@iceblue}{true}
\ifthenelse{\equal{\kit@colorscheme}{white}}{\setboolean{kit@iceblue}{false}}{}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% load beamer class and required packages %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\LoadClass[covered,interpolate,aspectratio=\kit@aspectratio,t,\kit@beamer@fontsize]{beamer}

\RequirePackage{colorKIT}
\RequirePackage{toolKIT}
\RequirePackage{etoolbox}
\RequirePackage{xparse}
\RequirePackage{calc}
\RequirePackage{graphicx}
\RequirePackage{multimedia}
\RequirePackage{tikz}
\RequirePackage{tcolorbox}
\RequirePackage[absolute,overlay,quiet]{textpos}
\ifkit@english%
  \RequirePackage[german,main=english]{babel}
  \RequirePackage[english]{isodate}
\else%
  \RequirePackage[english,main=german]{babel}
  \RequirePackage[german]{isodate}
\fi
\RequirePackage{csquotes}
\RequirePackage{marvosym}
\RequirePackage{ccicons}
\RequirePackage[backend=biber,
                style=authoryear-comp,
                sorting=nyt,
                sortcites=false,
                maxnames=2,
                minnames=1,
                maxbibnames=10,
                minbibnames=3,
                abbreviate=true,
                doi=true,
                useprefix=true,
                giveninits=true, 
                uniquename=init,
                natbib=true,
                dashed=false]{biblatex}
\RequirePackage{hyperref}
\urlstyle{same}

%% disable standard navigation symbols
\beamertemplatenavigationsymbolsempty

%% set spacing for German date format
\ifkit@english\relax\else%
  \daymonthsepgerman{}
  \monthyearsepgerman{}{}
\fi

% biblatex settings
\setlength{\bibitemsep}{0.5\baselineskip}
\DeclareNameAlias{sortname}{family-given}
% remove "In:" from article entries
\renewbibmacro{in:}{%
  \ifentrytype{article}{}{\printtext{\bibstring{in}\intitlepunct}}%
}
% use "et al." instead of "u. a." also in German settings
\DefineBibliographyStrings{german}{
  andothers = {et\addabbrvspace al\adddot},
  andmore   = {et\addabbrvspace al\adddot},
}
% remove thinspace after . for dates in German settings
\DefineBibliographyExtras{german}{% from german.lbx
  \protected\def\mkbibdateshort#1#2#3{%
    \iffieldundef{#3}
    {}
    {\mkdayzeros{\thefield{#3}}\adddot
      \iffieldundef{#2}{}{}}%<-\thinspace removed
    \iffieldundef{#2}
    {}
    {\mkmonthzeros{\thefield{#2}}%
      \iffieldundef{#1}
      {}
      {\iffieldundef{#3}{/}{\adddot}}}%<-\thinspace removed
    \iffieldbibstring{#1}
    {\bibstring{\thefield{#1}}}
    {\dateeraprintpre{#1}\mkyearzeros{\thefield{#1}}}}%
}

%% origin of textblocks
\textblockorigin{0pt}{0pt} % upper left corner

%% setting up lengths
\newlength{\kit@paper@width}                 % width of entire paper
\setlength{\kit@paper@width}{\paperwidth}    % 128mm (4:3), 160mm (16:9), 160mm (16:10)
\newlength{\kit@paper@height}                % height of entire paper
\setlength{\kit@paper@height}{\paperheight}  %  96mm (4:3),  90mm (16:9), 100mm (16:10)

\newlength{\kit@text@marginleft}             % margin between left paper edge and text area
\newlength{\kit@text@marginright}            % margin between text area and right paper edge
\newlength{\kit@text@width}                  % width of text area

\newlength{\kit@frametitle@marginleft}       % margin between left paper edge and frame title box
\newlength{\kit@frametitle@marginright}      % margin between frame title box and right paper edge
\newlength{\kit@frametitle@width}            % width of frame title box
\newlength{\kit@frametitle@height}           % height of frame title box from top edge of paper
\newlength{\kit@frametitle@text@width}       % width of text area within frame title box  
\newlength{\kit@frametitle@text@height}      % height of text area with frame title box
\newlength{\kit@frametitle@text@upperleftx}  % x-coordinate of upper left corner of text area within frame title box
\newlength{\kit@frametitle@text@upperlefty}  % y-coordinate of upper left corner of text area within frame title box

\newlength{\kit@footer@date@leftx}           % x-coordinate of left edge of date field in footline
\newlength{\kit@footer@author@leftx}         % x-coordinate of left edge of author field in footline
\newlength{\kit@footer@height}               % height of footline from bottom edge of paper
\newlength{\kit@footer@unilogo@lowerrightx}  % x-coordinate of lower right corner of unilogo in footline
\newlength{\kit@footer@unilogo@lowerrighty}  % y-coordinate of lower right corner of unilogo in footline
\newlength{\kit@footer@unilogo@width}        % width of unilogo in footline

\newlength{\kit@pageprogress@linewidth}      % width of progress indicator at bottom of page

\newlength{\kit@titlepage@instlogo@width}    % width of institute's logo on title page
\newlength{\kit@titlepage@instlogo@centerx}  % x-coordinate of center of institute's logo on title page
\newlength{\kit@titlepage@instlogo@centery}  % y-coordinate of center of institute's logo on title page
\newlength{\kit@titlepage@unilogo@height}    % height of unilogo on title page
\newlength{\kit@titlepage@unilogo@width}     % width of unilogo on title page}
\newlength{\kit@titlepage@unilogo@centerx}   % x-coordinate of center of unilogo on title page
\newlength{\kit@titlepage@unilogo@centery}   % y-coordinate of center of unilogo on title page
\newlength{\kit@titlepage@image@height}      % height of image on title page
\newlength{\kit@titlepage@image@width}       % width of image on title page
\newlength{\kit@titlepage@image@leftx}       % x-coordinate of left edge of image on title page
\newlength{\kit@titlepage@image@rightx}      % x-coordinate of right edge of image on title page
\newlength{\kit@titlepage@image@lowery}      % y-coordinate of lower edge of image on title page 
\newlength{\kit@titlepage@image@centerx}     % x-coordinate of center of image on title page
\newlength{\kit@titlepage@image@centery}     % y-coordinate of center of image on title page
\newlength{\kit@titlepage@cbox@leftx}        % x-coordinate of left edge of colored box on title page
\newlength{\kit@titlepage@cbox@lowery}       % y-coordinate of lower edge of colored box on title page
\newlength{\kit@titlepage@cbox@width}        % width of colored box on title page
\newlength{\kit@titlepage@cbox@height}       % height of colored box on title page
\newlength{\kit@titlepage@tbox@upperleftx}   % x-coordinate of upper left corner of text box on title page
\newlength{\kit@titlepage@tbox@upperlefty}   % y-coordinate of upper left corner of text box on title page
\newlength{\kit@titlepage@tbox@width}        % width of text box on title page
\newlength{\kit@titlepage@tbox@height}       % height of text box on title page
\newlength{\kit@titlepage@tbox@vspace}       % separation between title and subtitle on title page
\newlength{\kit@titlepage@dbox@width}        % width of date box on title page
\newlength{\kit@titlepage@dbox@lowerleftx}   % x-coordinate of lower left corner of date box on title page
\newlength{\kit@titlepage@dbox@lowerlefty}   % y-coordinate of lower left corner of date box on title page
\newlength{\kit@toc@cbox@leftx}              % x-coordinate of left edge of colored box on toc page
\newlength{\kit@toc@unilogo@centerx}         % x-coordinate of center of unilogo on toc page
\newlength{\kit@toc@unilogo@centery}         % y-coordinate of center of unilogo on toc page
\newlength{\kit@toc@unilogo@width}           % width of unilogo on toc page
\newlength{\kit@toc@unilogo@height}          % height of unilogo on toc page
\newlength{\kit@toc@title@width}             % width of title on toc page
\newlength{\kit@toc@tbox@width}              % width of text box on toc page
\newlength{\kit@toc@tbox@upperleftx}         % x-coordinate of upper left corner of text box on toc page
\newlength{\kit@toc@tbox@upperlefty}         % y-coordinate of upper left corner of text box on toc page
\newlength{\kit@endpage@unilogo@width}       % width of unilogo on end page
\newlength{\kit@endpage@torn@leftx}          % x-coordinate of torn paper on non-KIT version of end page
\newlength{\kit@sectionpage@image@width}     % width of image on section page
\newlength{\kit@sectionpage@image@height}    % height of image on section page
\newlength{\kit@sectionpage@image@leftx}     % x-coordinate of left edge of image on section page
\newlength{\kit@sectionpage@image@rightx}    % x-coordinate of right edge of image on section page
\newlength{\kit@sectionpage@image@lowery}    % y-coordinate of lower edge of image on section page 
\newlength{\kit@sectionpage@image@centerx}   % x-coordinate of center of image on section page
\newlength{\kit@sectionpage@image@centery}   % y-coordinate of center of image on section page
\newlength{\kit@sectionpage@tbox@upperleftx} % x-coordinate of upper left corner of text box on section page
\newlength{\kit@sectionpage@tbox@upperlefty} % y-coordinate of upper left corner of text box on secion page
\newlength{\kit@sectionpage@tbox@width}      % width of text box on section page
\newlength{\kit@sectionpage@tbox@height}     % height of text box on section page
\newlength{\kit@partpage@tbox@width}         % width of text box on part page

\newlength{\kit@tmplen}
\newlength{\kit@tmphig}
\newlength{\kit@tmpwid}

\ifthenelse{\equal{\kit@aspectratio}{43}}{
  \setlength{\kit@text@marginleft}{0.030473\kit@paper@width}
  \setlength{\kit@text@marginright}{\kit@text@marginleft}
  \setlength{\kit@text@width}{\kit@paper@width-\kit@text@marginleft-\kit@text@marginright}
  \setlength{\kit@frametitle@marginleft}{\kit@text@marginleft}
  \setlength{\kit@frametitle@marginright}{\kit@text@marginright}
  \setlength{\kit@frametitle@width}{\kit@text@width}
  \setlength{\kit@frametitle@text@width}{\kit@frametitle@width}
  \setlength{\kit@frametitle@text@height}{0.15\kit@paper@height}
  \setlength{\kit@frametitle@text@upperleftx}{\kit@frametitle@marginleft}
  \setlength{\kit@frametitle@text@upperlefty}{0.96\kit@paper@height}
  \setlength{\kit@frametitle@height}{\kit@paper@height-\kit@frametitle@text@upperlefty+\kit@frametitle@text@height}
  \ifkit@showtotal%
  \setlength{\kit@footer@date@leftx}{\kit@text@marginleft+3em}
  \setlength{\kit@footer@author@leftx}{\kit@footer@date@leftx+5em}
  \else%
  \setlength{\kit@footer@date@leftx}{\kit@text@marginleft+2em}
  \setlength{\kit@footer@author@leftx}{\kit@footer@date@leftx+4.5em}
  \fi
  \setlength{\kit@footer@unilogo@lowerrightx}{0.9702947\kit@paper@width}
  \setlength{\kit@footer@unilogo@lowerrighty}{0.02530184\kit@paper@height}
  \setlength{\kit@footer@unilogo@width}{0.056516861\kit@paper@width}
  \setlength{\kit@footer@height}{1.6\kit@footer@unilogo@lowerrighty+0.359069\kit@footer@unilogo@width} % 0.359069=aspectratio of unilogo
  \setlength{\kit@pageprogress@linewidth}{3pt}
  \setlength{\kit@titlepage@unilogo@width}{0.07069\kit@paper@width}
  \setlength{\kit@titlepage@unilogo@height}{0.359069\kit@titlepage@unilogo@width} % 0.359069=aspectratio of unilogo (816px x 293px)
  \setlength{\kit@titlepage@unilogo@centerx}{0.913866\kit@paper@width}
  \setlength{\kit@titlepage@unilogo@centery}{0.96\kit@paper@height-0.5\kit@titlepage@unilogo@height}
  \setlength{\kit@titlepage@instlogo@width}{0.10922459\kit@paper@width}
  \setlength{\kit@titlepage@instlogo@centerx}{\kit@titlepage@unilogo@centerx}
  \setlength{\kit@titlepage@instlogo@centery}{0.1\kit@paper@height}
  \setlength{\kit@toc@cbox@leftx}{0.49114\kit@paper@width+0.33656\kit@paper@width}
  \setlength{\kit@toc@unilogo@centerx}{\kit@titlepage@unilogo@centerx}
  \setlength{\kit@toc@unilogo@centery}{\kit@titlepage@unilogo@centery}
  \setlength{\kit@toc@unilogo@width}{\kit@titlepage@unilogo@width}
  \setlength{\kit@toc@unilogo@height}{\kit@titlepage@unilogo@height}
  \setlength{\kit@toc@title@width}{0.15\kit@paper@width}
  \setlength{\kit@toc@tbox@upperleftx}{1.6\kit@frametitle@marginleft+\kit@toc@title@width}
  \setlength{\kit@toc@tbox@upperlefty}{\kit@frametitle@text@upperlefty}
  \setlength{\kit@toc@tbox@width}{\kit@toc@cbox@leftx-\kit@toc@tbox@upperleftx}
  \setlength{\kit@endpage@unilogo@width}{0.1\kit@paper@width}
  \setlength{\kit@endpage@torn@leftx}{0.1\kit@paper@width}
  \setlength{\kit@sectionpage@image@width}{\kit@paper@width}
  \setlength{\kit@sectionpage@image@height}{0.55759\kit@paper@height}
  \setlength{\kit@sectionpage@image@leftx}{0pt}
  \setlength{\kit@sectionpage@image@rightx}{\kit@paper@width}
  \setlength{\kit@sectionpage@image@lowery}{\kit@paper@height-\kit@sectionpage@image@height}
  \setlength{\kit@sectionpage@image@centerx}{0.5\kit@paper@width}
  \setlength{\kit@sectionpage@image@centery}{\kit@sectionpage@image@lowery+0.5\kit@sectionpage@image@height}
  \setlength{\kit@sectionpage@tbox@upperleftx}{0.030473\kit@paper@width}
  \setlength{\kit@sectionpage@tbox@upperlefty}{0.410656168\kit@paper@height}
  \setlength{\kit@sectionpage@tbox@width}{0.82770\kit@paper@width-\kit@sectionpage@tbox@upperleftx}
  \setlength{\kit@sectionpage@tbox@height}{0.2466142\kit@paper@height}
  \setlength{\kit@partpage@tbox@width}{\kit@text@width}
}{}
\ifthenelse{\equal{\kit@aspectratio}{169} \OR \equal{\kit@aspectratio}{1610}}{
  \setlength{\kit@text@marginleft}{0.030473\kit@paper@width}
  \setlength{\kit@text@marginright}{\kit@text@marginleft}
  \setlength{\kit@text@width}{\kit@paper@width-\kit@text@marginleft-\kit@text@marginright}
  \setlength{\kit@frametitle@marginleft}{\kit@text@marginleft}
  \setlength{\kit@frametitle@marginright}{\kit@text@marginright}
  \setlength{\kit@frametitle@width}{\kit@text@width}
  \setlength{\kit@frametitle@text@width}{\kit@frametitle@width}
  \setlength{\kit@frametitle@text@height}{0.146824147\kit@paper@height}
  \setlength{\kit@frametitle@text@upperleftx}{\kit@frametitle@marginleft}
  \setlength{\kit@frametitle@text@upperlefty}{0.94619423\kit@paper@height}
  \setlength{\kit@frametitle@height}{\kit@paper@height-\kit@frametitle@text@upperlefty+\kit@frametitle@text@height}
  \ifkit@showtotal%
  \setlength{\kit@footer@date@leftx}{\kit@text@marginleft+3em}
  \setlength{\kit@footer@author@leftx}{\kit@footer@date@leftx+5em}
  \else%
  \setlength{\kit@footer@date@leftx}{\kit@text@marginleft+2em}
  \setlength{\kit@footer@author@leftx}{\kit@footer@date@leftx+4.5em}
  \fi
  \setlength{\kit@footer@unilogo@lowerrightx}{0.9702947\kit@paper@width}
  \setlength{\kit@footer@unilogo@lowerrighty}{0.02530184\kit@paper@height}
  \setlength{\kit@footer@unilogo@width}{0.056516861\kit@paper@width}
  \setlength{\kit@footer@height}{1.6\kit@footer@unilogo@lowerrighty+0.359069\kit@footer@unilogo@width} % 0.359069=aspectratio of unilogo
  \setlength{\kit@pageprogress@linewidth}{3pt}
  \setlength{\kit@titlepage@unilogo@width}{0.07069\kit@paper@width}
  \setlength{\kit@titlepage@unilogo@height}{0.359069\kit@titlepage@unilogo@width} % 0.359069=aspectratio of unilogo (816px x 293px)
  \setlength{\kit@titlepage@unilogo@centerx}{0.913866\kit@paper@width}
  \setlength{\kit@titlepage@unilogo@centery}{0.923727\kit@paper@height}
  \setlength{\kit@titlepage@instlogo@width}{0.10922459\kit@paper@width}
  \setlength{\kit@titlepage@instlogo@centerx}{\kit@titlepage@unilogo@centerx}
  \setlength{\kit@titlepage@instlogo@centery}{0.13769\kit@paper@height}
  \setlength{\kit@toc@cbox@leftx}{0.49114\kit@paper@width+0.33656\kit@paper@width}
  \setlength{\kit@toc@unilogo@centerx}{\kit@titlepage@unilogo@centerx}
  \setlength{\kit@toc@unilogo@centery}{\kit@titlepage@unilogo@centery}
  \setlength{\kit@toc@unilogo@width}{\kit@titlepage@unilogo@width}
  \setlength{\kit@toc@unilogo@height}{\kit@titlepage@unilogo@height}
  \setlength{\kit@toc@title@width}{0.15\kit@paper@width}
  \setlength{\kit@toc@tbox@upperleftx}{1.6\kit@frametitle@marginleft+\kit@toc@title@width}
  \setlength{\kit@toc@tbox@upperlefty}{\kit@frametitle@text@upperlefty}
  \setlength{\kit@toc@tbox@width}{\kit@toc@cbox@leftx-\kit@toc@tbox@upperleftx}
  \setlength{\kit@endpage@unilogo@width}{0.1\kit@paper@width}
  \setlength{\kit@endpage@torn@leftx}{0.1\kit@paper@width}
  \setlength{\kit@sectionpage@image@width}{\kit@paper@width}
  \setlength{\kit@sectionpage@image@height}{0.55759\kit@paper@height}
  \setlength{\kit@sectionpage@image@leftx}{0pt}
  \setlength{\kit@sectionpage@image@rightx}{\kit@paper@width}
  \setlength{\kit@sectionpage@image@lowery}{\kit@paper@height-\kit@sectionpage@image@height}
  \setlength{\kit@sectionpage@image@centerx}{0.5\kit@paper@width}
  \setlength{\kit@sectionpage@image@centery}{\kit@sectionpage@image@lowery+0.5\kit@sectionpage@image@height}
  \setlength{\kit@sectionpage@tbox@upperleftx}{0.030473\kit@paper@width}
  \setlength{\kit@sectionpage@tbox@upperlefty}{0.410656168\kit@paper@height}
  \setlength{\kit@sectionpage@tbox@width}{0.82770\kit@paper@width-\kit@sectionpage@tbox@upperleftx}
  \setlength{\kit@sectionpage@tbox@height}{0.2466142\kit@paper@height}
  \setlength{\kit@partpage@tbox@width}{\kit@text@width}
}{}

%%%%%%%%%%%%%%%%%%%%%
%% load KIT themes %%
%%%%%%%%%%%%%%%%%%%%%

\usecolortheme{KIT}
\usefonttheme{KIT}
\useoutertheme{KIT}
\useinnertheme{KIT}

%% (language-specific) KIT text and logos
\newboolean{KITconfidential}
\newboolean{kit@lic}
\newcommand{\kit@licenseA@de}{Ver\"offentlicht unter}
\newcommand{\kit@licenseB@de}{Lizenz.}
\newcommand{\kit@licenseA@en}{Published under}
\newcommand{\kit@licenseB@en}{license.}
\newcommand{\kit@licenseA}{\@empty}
\newcommand{\kit@licenseB}{\@empty}
\newcommand{\kit@confidential@de}{--\,vertraulich\,--}
\newcommand{\kit@confidential@en}{--\,confidential\,--}
\newcommand{\kit@confidential}{\@empty}
\newcommand{\kit@sectionpage@intro@de}{Kapitel}
\newcommand{\kit@sectionpage@intro@en}{Section}
\newcommand{\kit@sectionpage@intro}{\@empty}
\newcommand{\kit@partpage@intro@de}{Teil}
\newcommand{\kit@partpage@intro@en}{Part}
\newcommand{\kit@partpage@intro}{\@empty}
\newcommand{\kit@tocpage@intro@de}{Inhalt}
\newcommand{\kit@tocpage@intro@en}{Content}
\newcommand{\kit@tocpage@intro}{\@empty}
\ifkit@english%
  \renewcommand{\kit@licenseA}{\kit@licenseA@en\relax}
  \renewcommand{\kit@licenseB}{\kit@licenseB@en\relax}
  \renewcommand{\kit@confidential}{\kit@confidential@en\relax}
  \renewcommand{\kit@sectionpage@intro}{\kit@sectionpage@intro@en\relax}
  \renewcommand{\kit@partpage@intro}{\kit@partpage@intro@en\relax}
  \renewcommand{\kit@tocpage@intro}{\kit@tocpage@intro@en\relax}
\else%
  \renewcommand{\kit@licenseA}{\kit@licenseA@de\relax}
  \renewcommand{\kit@licenseB}{\kit@licenseB@de\relax}
  \renewcommand{\kit@confidential}{\kit@confidential@de\relax}
  \renewcommand{\kit@sectionpage@intro}{\kit@sectionpage@intro@de\relax}
  \renewcommand{\kit@partpage@intro}{\kit@partpage@intro@de\relax}
  \renewcommand{\kit@tocpage@intro}{\kit@tocpage@intro@de\relax}
\fi
\newcommand{\kit@web}{www.kit.edu}
\ifthenelse{\equal{\kit@license}{none}}{%
  \setboolean{kit@lic}{false}
  \renewcommand{\kit@licenseA}{\@empty}
  \renewcommand{\kit@licenseA}{\@empty}
}{%
  \setboolean{kit@lic}{true}
}
\setboolean{KITconfidential}{false}

%% license-related settings
\newcommand{\kit@liclogo@type}{\@empty}
\ifthenelse{\equal{\kit@license}{ccby}}{%
  \renewcommand{\kit@liclogo@type}{\ccby}%
}{%
  \ifthenelse{\equal{\kit@license}{ccbysa}}{%
    \renewcommand{\kit@liclogo@type}{\ccbysa}%
  }{%
    \ifthenelse{\equal{\kit@license}{ccbynd}}{%
      \renewcommand{\kit@liclogo@type}{\ccbynd}%
    }{%
      \ifthenelse{\equal{\kit@license}{ccbync}}{%
        \renewcommand{\kit@liclogo@type}{\ccbync}%
      }{%
        \ifthenelse{\equal{\kit@license}{ccbyncsa}}{%
          \renewcommand{\kit@liclogo@type}{\ccbyncsa}%
        }{%
          \ifthenelse{\equal{\kit@license}{ccbyncnd}}{%
            \renewcommand{\kit@liclogo@type}{\ccbyncnd}%
          }{}%
        }%
      }%
    }%
  }%
}

%% internal commands
\newcommand{\kit@endpage@default}{kit}
\ifthenelse{\equal{\kit@design}{gpi}}{\renewcommand{\kit@endpage@default}{gpi}}{}
\newcommand{\kit@titlepage@unilogo@file}{\@empty}
\newcommand{\kit@titlepage@instlogo@file}{\@empty}
\newcommand{\kit@footer@unilogo@file}{corefig/kitlogo_color}
\newcommand{\kit@toc@unilogo@file}{corefig/kitlogo_color}
\newcommand{\kit@toc@background}{KITwhite}
\newcommand{\kit@titlepage@image}{\@empty}
\newcommand{\kit@titlepage@background}{\@empty}
\newcommand{\kit@titlepage@orientation}{\@empty}
\newcommand{\kit@titlepage@logo}{\@empty}
\newcommand{\kit@sectionpage@image}{\@empty}
\newcommand{\kit@sectionpage@logo}{\@empty}
\newcommand{\kit@sectionpage@unilogo@file}{\@empty}
\newcommand{\kit@sectionpage@textcolor}{\@empty}
\newcommand{\kit@sectionpage@numcolor}{\@empty}
\newcommand{\kit@partpage@textcolor}{\@empty}
\newcommand{\kit@tocpage@background}{\@empty}
\newcommand{\kit@tocpage@logo}{\@empty}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% beamer-related KIT commands %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% KITvfill
\newcommand{\KITvfill}{\par\vskip 0pt plus 1filll\par}

%% KITleftmargin, KITrightmargin
\newcommand{\KITleftmargin}{\kit@text@marginleft}
\newcommand{\KITrightmargin}{\kit@text@marginright}

%% KITusenavsym
\newboolean{kit@nav@use}
\setboolean{kit@nav@use}{false}
\DeclareDocumentCommand \KITusenavsym { O{sHb} } {%
  \ifkit@nav@use%
    \ClassError{beamerKIT}%
               {\KITusenavsym called multiple times}%
               {You can only call \KITusenavsym once}%
  \else\setboolean{kit@nav@use}{true}\fi%
  \xdef\kit@nav@syms{#1!}%
}

%% KITinstlogo
\DeclareDocumentCommand \KITinstlogo { o m } {%
  \renewcommand{\kit@titlepage@instlogo@file}{#2}%
  \newboolean{kit@rescale}%
  \IfValueTF {#1} {%
    \ifthenelse{\equal{#1}{relaxed}}{\setboolean{kit@rescale}{false}}{\setboolean{kit@rescale}{true}}%
  }{\setboolean{kit@rescale}{true}}%
  \ifkit@rescale%
  % rescale institute logo in case it appears too large
  \settoheight{\kit@tmplen}{\includegraphics[width=\kit@titlepage@instlogo@width]{\kit@titlepage@instlogo@file}}%
  \ifthenelse{\dimtest{\kit@tmplen}{>}{1.3\kit@titlepage@unilogo@height}}{%
    \ClassWarningNoLine{beamerKIT}{%
The additional institute logo has been rescaled as an %
additional logo must not overshadow the KIT logo}%
    \logo{\includegraphics[height=1.3\kit@titlepage@unilogo@height,keepaspectratio]{\kit@titlepage@instlogo@file}}
  }{%
    \logo{\includegraphics[width=\kit@titlepage@instlogo@width]{\kit@titlepage@instlogo@file}}
  }%
  \else%
    \logo{\includegraphics[width=\kit@titlepage@instlogo@width]{\kit@titlepage@instlogo@file}}
  \fi%
}

%% KITtitlepage
\define@choicekey*{titlepage}{image}{fit,scale,clip}[fit]{\renewcommand{\kit@titlepage@image}{#1}}
\define@choicekey*{titlepage}{orientation}{vertical,horizontal}[vertical]{\renewcommand{\kit@titlepage@orientation}{#1}}
\define@choicekey*{titlepage}{background}{KITwhite,KITdarkblue,KITbluegreen}[KITwhite]{\renewcommand{\kit@titlepage@background}{#1}}
\define@choicekey*{titlepage}{logo}{white,black,color,none}[color]{\renewcommand{\kit@titlepage@logo}{#1}}
\presetkeys{titlepage}{image=fit,orientation=vertical,background=KITwhite,logo=color}{}
\newsavebox{\mytimg}

\DeclareDocumentCommand \KITtitlepage { o +g } {%
  \IfValueTF {#1} {\setkeys{titlepage}{#1}}{\setkeys{titlepage}{}}
  \colorlet{KITtitlepageboxcolor}{KITwhite}
  \ifthenelse{\equal{\kit@titlepage@background}{KITbluegreen}}{\colorlet{KITtitlepageboxcolor}{KITbluegreen}}{}
  \ifthenelse{\equal{\kit@titlepage@background}{KITdarkblue}}{\colorlet{KITtitlepageboxcolor}{KITdarkblue}}{}
  \renewcommand{\kit@titlepage@unilogo@file}{\@empty}
  \ifthenelse{\equal{\kit@titlepage@logo}{color}}{\renewcommand{\kit@titlepage@unilogo@file}{corefig/kitlogo_color}}{}
  \ifthenelse{\equal{\kit@titlepage@logo}{black}}{\renewcommand{\kit@titlepage@unilogo@file}{corefig/kitlogo_black}}{}
  \ifthenelse{\equal{\kit@titlepage@logo}{white}}{\renewcommand{\kit@titlepage@unilogo@file}{corefig/kitlogo_white}}{}
  \ifthenelse{\equal{\kit@titlepage@orientation}{vertical}}{% title page with vertical image
    \PackageInfo{beamerKIT}{Vertical titlepage selected}%
    \setlength{\kit@titlepage@image@width}{0.33656\kit@paper@width}
    \setlength{\kit@titlepage@image@height}{\kit@paper@height}
    \setlength{\kit@titlepage@image@leftx}{0.49114\kit@paper@width}
    \setlength{\kit@titlepage@image@rightx}{\kit@titlepage@image@leftx+\kit@titlepage@image@width}
    \setlength{\kit@titlepage@image@lowery}{0pt}
    \setlength{\kit@titlepage@image@centerx}{\kit@titlepage@image@leftx+0.5\kit@titlepage@image@width}
    \setlength{\kit@titlepage@image@centery}{0.5\kit@paper@height}
    \setlength{\kit@titlepage@cbox@leftx}{\kit@titlepage@image@rightx}
    \setlength{\kit@titlepage@cbox@lowery}{0pt}
    \setlength{\kit@titlepage@cbox@width}{\kit@paper@width-\kit@titlepage@image@rightx}
    \setlength{\kit@titlepage@cbox@height}{\kit@paper@height}
    \setlength{\kit@titlepage@tbox@upperleftx}{0.030473\kit@paper@width}
    \ifthenelse{\equal{\insertaspectratio}{43}}{%
      \setlength{\kit@titlepage@tbox@upperlefty}{0.96\kit@paper@height}%
    }{%
      \setlength{\kit@titlepage@tbox@upperlefty}{0.946299\kit@paper@height}%
    }
    \setlength{\kit@titlepage@tbox@width}{\kit@titlepage@image@leftx-2\kit@titlepage@tbox@upperleftx}
    \setlength{\kit@titlepage@tbox@height}{0.6\kit@paper@height}
    \setlength{\kit@titlepage@tbox@vspace}{10pt}
    \setlength{\kit@titlepage@dbox@width}{\kit@titlepage@tbox@width}
    \setlength{\kit@titlepage@dbox@lowerleftx}{0.030473\kit@paper@width}
    \ifthenelse{\equal{\insertaspectratio}{43}}{%
      \setlength{\kit@titlepage@dbox@lowerlefty}{0.05\kit@paper@height}%
    }{%
      \setlength{\kit@titlepage@dbox@lowerlefty}{0.0847769\kit@paper@height}%
    }
  }{% title page with horizontal image
    \PackageInfo{beamerKIT}{Horizontal titlepage selected}%
    \setlength{\kit@titlepage@image@width}{\kit@paper@width}
    \setlength{\kit@titlepage@image@height}{0.55759\kit@paper@height}
    \setlength{\kit@titlepage@image@leftx}{0pt}
    \setlength{\kit@titlepage@image@rightx}{\kit@paper@width}
    \setlength{\kit@titlepage@image@lowery}{\kit@paper@height-\kit@titlepage@image@height}
    \setlength{\kit@titlepage@image@centerx}{0.5\kit@paper@width}
    \setlength{\kit@titlepage@image@centery}{\kit@titlepage@image@lowery+0.5\kit@titlepage@image@height}
    \setlength{\kit@titlepage@cbox@leftx}{0pt}
    \setlength{\kit@titlepage@cbox@lowery}{0pt}
    \setlength{\kit@titlepage@cbox@width}{\kit@paper@width}
    \setlength{\kit@titlepage@cbox@height}{\kit@paper@height-\kit@titlepage@image@height}
    \setlength{\kit@titlepage@tbox@upperleftx}{0.030473\kit@paper@width}
    \setlength{\kit@titlepage@tbox@upperlefty}{0.410656168\kit@paper@height}
    % allow wider text box when no institute logo is used
    \ifthenelse{\equal{\kit@titlepage@instlogo@file}{\@empty}} {%
      \setlength{\kit@titlepage@tbox@width}{\kit@paper@width-\kit@text@marginright-\kit@titlepage@tbox@upperleftx}
     }{%
      \setlength{\kit@titlepage@tbox@width}{0.82770\kit@paper@width-\kit@titlepage@tbox@upperleftx}
    }
    \setlength{\kit@titlepage@tbox@height}{0.2466142\kit@paper@height}
    \setlength{\kit@titlepage@tbox@vspace}{5pt}
    \setlength{\kit@titlepage@dbox@width}{\kit@titlepage@tbox@width}
    \setlength{\kit@titlepage@dbox@lowerleftx}{0.030473\kit@paper@width}
    \ifthenelse{\equal{\insertaspectratio}{43}}{%
      \setlength{\kit@titlepage@dbox@lowerlefty}{0.05\kit@paper@height}%
    }{%
      \setlength{\kit@titlepage@dbox@lowerlefty}{0.0847769\kit@paper@height}%
    }
  }
  \IfValueTF {#2} {%
    % scale: fit width and height while possibly distorting the aspectratio
    \ifthenelse{\equal{\kit@titlepage@image}{scale}}{%
      \titlegraphic{\includegraphics[width=\kit@titlepage@image@width,height=\kit@titlepage@image@height]{#2}}}{}
    % clip: fit the smaller dimension while keeping the aspectratio and cut off the larger dimension
    \ifthenelse{\equal{\kit@titlepage@image}{clip}}{%
      \savebox{\mytimg}{\includegraphics{#2}}
      \settowidth{\kit@tmplen}{\usebox{\mytimg}}
      \settoheight{\kit@tmphig}{\usebox{\mytimg}}
      \pgfmathsetmacro{\scale@facx}{\kit@tmplen/\kit@titlepage@image@width}%
      \pgfmathsetmacro{\scale@facy}{\kit@tmphig/\kit@titlepage@image@height}%
      \ifthenelse{\lengthtest{\scale@facx pt > \scale@facy pt}}{%
        \pgfmathsetmacro{\scale@fac}{\kit@titlepage@image@height/\kit@tmphig}%
      }{%
        \pgfmathsetmacro{\scale@fac}{\kit@titlepage@image@width/\kit@tmplen}%
      }
      \titlegraphic{\includegraphics[scale=\scale@fac]{#2}}%
    }{}
    % fit: fit the larger dimension while keeping the aspectratio and leave empty space in the other dimension
    \ifthenelse{\equal{\kit@titlepage@image}{fit}}{%
      \titlegraphic{\includegraphics[width=\kit@titlepage@image@width,height=\kit@titlepage@image@height,keepaspectratio]{#2}}}{}
  }{\titlegraphic{}}
  \begingroup
  \setbeamertemplate{background}{}%
  \setbeamertemplate{navigation symbols}{}%
  \setbeamertemplate{footline}{}%
  \frame[plain]{\titlepage}%
  \endgroup
}

%% KITtoc
% beamer spreads out toc entries using vfill without the possibility to alter this
% behavior; patching macros to have a constant item separation on the toc page
% evil hack begin
\ifkit@strict%
\patchcmd{\beamer@sectionintoc}{\vfill}{\vskip3\itemsep}{}{}
\pretocmd{\beamer@subsectionintoc}{\vskip0.5\itemsep}{}{}
\else
\patchcmd{\beamer@sectionintoc}{\vfill}{\vskip2\itemsep}{}{}
\pretocmd{\beamer@subsectionintoc}{\vskip0.25\itemsep}{}{}
\fi
% evil hack end
\define@choicekey*{tocpage}{background}{KITwhite,KITdarkblue}[KITwhite]{\renewcommand{\kit@tocpage@background}{#1}}
\presetkeys{tocpage}{background=KITwhite}{}

\DeclareDocumentCommand \KITtoc { o m o } {%
  \IfValueTF {#3} {\setkeys{tocpage}{#3}}{\setkeys{tocpage}{}}
  \ifthenelse{\equal{\kit@tocpage@background}{KITwhite}}{%
    \renewcommand{\kit@toc@unilogo@file}{corefig/kitlogo_color}%
    \colorlet{KITtocboxcolor}{KITwhite}
  }{%
    \renewcommand{\kit@toc@unilogo@file}{corefig/kitlogo_white}%
    \colorlet{KITtocboxcolor}{KITdarkblue}
  }
  \begingroup
  \setbeamertemplate{navigation symbols}{}%
  \setbeamertemplate{footline}{}%
  \setbeamertemplate{background}{%
    \begin{tikzpicture}%
      \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@paper@height);
      \fill[KITbluegreen] (0,0) rectangle (\kit@toc@cbox@leftx,\kit@paper@height);%
      % color box
      \fill[KITtocboxcolor] (\kit@toc@cbox@leftx,0) rectangle (\kit@paper@width,\kit@paper@height);%
      % set KIT logo
      \ifthenelse{\equal{\kit@toc@unilogo@file}{\@empty}}{}{%
        \node[inner sep=0pt,outer sep=0pt] (toclogo) at (\kit@toc@unilogo@centerx,\kit@toc@unilogo@centery)%
          {\includegraphics[width=\kit@toc@unilogo@width]{\kit@toc@unilogo@file}};%
      }%
    \end{tikzpicture}%
  }%
  \ifkit@strict%
  \settoheight{\kit@tmphig}{{\usebeamerfont{toctitle}\usebeamercolor*[fg]{subsection in toc}#2}}%
  \begin{frame}[t,plain]{}%
    \noindent%
    \begin{textblock*}{\kit@toc@title@width}(\kit@frametitle@text@upperleftx,\kit@paper@height-\kit@frametitle@text@upperlefty)%
      {%
        \tcbset{notitle,nobeforeafter,halign=flush left,valign=top,enhanced,opacityfill=0,%
                fit algorithm=fontsize,size=minimal,fit fontsize macros}
        \tcboxfit[width=\kit@toc@title@width,height=0.5\kit@paper@height,fit warning=off]{%
          {\usebeamerfont*{toctitle}\usebeamercolor*[fg]{subsection in toc}#2}
        }%
      }
    \end{textblock*}%
    \begin{textblock*}{\kit@toc@tbox@width}(\kit@toc@tbox@upperleftx,\kit@paper@height-\kit@toc@tbox@upperlefty+\kit@tmphig)%
      \IfValueTF {#1}{\tableofcontents[#1]}{\tableofcontents}
    \end{textblock*}%
  \end{frame}%
  \else%
  {%
    \setbeamercolor{frametitle}{fg=KITwhite}%
    \advance\kit@frametitle@text@width by \kit@toc@cbox@leftx
    \advance\kit@frametitle@text@width by -\kit@paper@width
    \begin{frame}[t,plain]{#2}%
      \IfValueTF {#1}{\tableofcontents[#1]}{\tableofcontents}%
    \end{frame}%
  }%
  \fi%
  \endgroup%
}

%% KITendpage
\DeclareDocumentCommand \KITendpage { O{\kit@endpage@default} +g } {%
  \begingroup
  \newboolean{kit@standard}
  \IfValueT{#1}{\ifthenelse{\equal{#1}{kit}}{\setboolean{kit@standard}{true}}{\setboolean{kit@standard}{false}}}
  \ifkit@standard%
  {%
    \setbeamertemplate{background}{}
    \setbeamertemplate{navigation symbols}{}
    \setbeamertemplate{footline}{}
    \begin{frame}[c]
      \begin{textblock*}{\kit@paper@width}(0pt,0pt)
        \begin{tikzpicture}
          \node[inner sep=0pt] at (0,0) {};
          \node[inner sep=0pt] at (0.5\kit@paper@width,-0.5\kit@paper@height)%
            {\includegraphics[width=\kit@endpage@unilogo@width]{corefig/kitlogo_color}};
        \end{tikzpicture}
      \end{textblock*}
    \end{frame}
  }%
  \else%
  {%
    \setbeamertemplate{background}{}
    \setbeamertemplate{navigation symbols}{}
    \setbeamertemplate{footline}{
      \begin{tikzpicture}
        \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@footer@height);
        \node[inner sep=0pt,outer sep=0pt,anchor=south east] (kitlogo) at (\kit@footer@unilogo@lowerrightx,\kit@footer@unilogo@lowerrighty)%
        {\href{https://www.kit.edu}{\includegraphics[width=\kit@footer@unilogo@width]{\kit@footer@unilogo@file}}};%
      \end{tikzpicture}%
    }
    \begin{frame}[c]
      \begin{textblock*}{2cm}(\kit@endpage@torn@leftx,0pt)
        \includegraphics[width=1.75cm]{corefig/tornpaper}
      \end{textblock*}
      \begin{textblock*}{0.5\kit@paper@width}(0.3\paperwidth,0.25\paperheight)%
        \centering
        \ifkit@english%
        {\usebeamerfont{title on endpage}{Thank you for\linebreak your attention}}\\[2\baselineskip]
        \else%
        {\usebeamerfont{title on endpage}{Vielen Dank\linebreak f\"ur Ihre\linebreak Aufmerksamkeit}}\\[2\baselineskip]
        \fi%
        \IfValueTF {#2} {%
          \begin{tabular}{ll}%
            \raisebox{-0.5ex}{\scalebox{1.5}{\Email}} & {\normalsize #2}\\[1mm]%
            \raisebox{-0.4ex}{\scalebox{1.5}{\Mundus}} & {\normalsize \href{https://www.gpi.kit.edu}{https://www.gpi.kit.edu}}\\[7mm]%
            \ifkit@lic%
            \multicolumn{2}{l}{\kit@licenseA~~\kit@liclogo@type~~\kit@licenseB}%
            \else\relax\fi%
          \end{tabular}
        }{\relax}
      \end{textblock*}
    \end{frame}
  }%
  \fi%
  \endgroup%
}

%% KITcontentgeom: provide a user command to determine actual height of text area; 
%% beamer's standard textheight is incorrect
\newlength{\contentwidth}
\setlength{\contentwidth}{\textwidth}
\newlength{\contentleft}
\setlength{\contentleft}{\kit@text@marginleft}
\newlength{\contentheight}
\DeclareDocumentCommand \KITcontentgeom { } {%
  \ifbeamer@plainframe%
    \setlength{\contentheight}{\paperheight}%
  \else%
    \setlength{\contentheight}{\textheight}%
  \fi%
  \ifx\beamer@frametitle\@empty%
    \setbox\@tempboxa=\box\voidb@x%
  \else%
    \setbox\@tempboxa=\vbox{%
      \vbox{}%
      {\parskip0pt\usebeamertemplate***{frametitle}}%
    }%
    \advance\contentheight by-1em% sidebartheme
  \fi%
  \advance\contentheight by-\ht\@tempboxa%
  \advance\contentheight by-\dp\@tempboxa%
  \advance\contentheight by-\beamer@frametopskip%
  \ifdim\ht\@tempboxa=0pt\relax\else%
  \advance\contentheight by\dimexpr\kit@beamer@fontsize-2pt\fi%
}

%% KITsectionpage
\define@choicekey*{sectionpage}{image}{fit,scale,clip}[fit]{\renewcommand{\kit@sectionpage@image}{#1}}
\define@key{sectionpage}{background}[KITbluegreen]{\colorlet{KITsectionpagecolor}{#1}}
\define@key{sectionpage}{textcolor}[KITwhite]{\renewcommand{\kit@sectionpage@textcolor}{#1}}
\define@key{sectionpage}{numcolor}[KITsectionnumberdefault]{\renewcommand{\kit@sectionpage@numcolor}{#1}}
\define@choicekey*{sectionpage}{logo}{white,black,color,none}[white]{\renewcommand{\kit@sectionpage@logo}{#1}}
\presetkeys{sectionpage}{image=fit,background=KITbluegreen,textcolor=KITwhite,numcolor=KITsectionnumberdefault,logo=white}{}
\newsavebox{\mysimg}

\DeclareDocumentCommand \KITsectionpage { o +g } {%
  \colorlet{KITsectionpagecolor}{KITbluegreen}
  \renewcommand{\kit@sectionpage@textcolor}{KITwhite}
  \renewcommand{\kit@sectionpage@numcolor}{KITsectionnumberdefault}
  \IfValueTF {#1} {\setkeys{sectionpage}{#1}}{\setkeys{sectionpage}{}}
  \renewcommand{\kit@sectionpage@unilogo@file}{}
  \def\kit@sectionpage@includeimage\@empty
  \ifthenelse{\equal{\kit@sectionpage@logo}{color}}{\renewcommand{\kit@sectionpage@unilogo@file}{corefig/kitlogo_color}}{}
  \ifthenelse{\equal{\kit@sectionpage@logo}{black}}{\renewcommand{\kit@sectionpage@unilogo@file}{corefig/kitlogo_black}}{}
  \ifthenelse{\equal{\kit@sectionpage@logo}{white}}{\renewcommand{\kit@sectionpage@unilogo@file}{corefig/kitlogo_white}}{}
  \IfValueTF {#2} {%
    % scale: fit width and height while possibly distorting the aspectratio
    \ifthenelse{\equal{\kit@sectionpage@image}{scale}}{%
      \gdef\kit@sectionpage@includeimage{\includegraphics[width=\kit@sectionpage@image@width,height=\kit@sectionpage@image@height]{#2}}}{}
    % clip: fit the smaller dimension while keeping the aspectratio and cut off the larger dimension
    \ifthenelse{\equal{\kit@sectionpage@image}{clip}}{%
      \savebox{\mysimg}{\includegraphics{#2}}
      \settowidth{\kit@tmplen}{\usebox{\mysimg}}
      \settoheight{\kit@tmphig}{\usebox{\mysimg}}
      \pgfmathsetmacro{\scale@facx}{\kit@tmplen/\kit@sectionpage@image@width}%
      \pgfmathsetmacro{\scale@facy}{\kit@tmphig/\kit@sectionpage@image@height}%
      \ifthenelse{\lengthtest{\scale@facx pt > \scale@facy pt}}{%
        \pgfmathsetmacro{\scale@fac}{\kit@sectionpage@image@height/\kit@tmphig}%
      }{%
        \pgfmathsetmacro{\scale@fac}{\kit@sectionpage@image@width/\kit@tmplen}%
      }
      \gdef\kit@sectionpage@includeimage{\includegraphics[scale=\scale@fac]{#2}}%
    }{}
    % fit: fit the larger dimension while keeping the aspectratio and leave empty space in the other dimension
    \ifthenelse{\equal{\kit@sectionpage@image}{fit}}{%
      \gdef\kit@sectionpage@includeimage{\includegraphics[width=\kit@sectionpage@image@width,height=\kit@sectionpage@image@height,keepaspectratio]{#2}}}{}
  }{\gdef\kit@sectionpage@includeimage{}}
  \begingroup
  \setbeamercolor{section number}{fg=\kit@sectionpage@numcolor}
  \setbeamercolor{section title}{fg=\kit@sectionpage@textcolor}
  \setbeamercolor{section intro}{fg=\kit@sectionpage@textcolor}
  \setbeamertemplate{background}{%
    \begin{tikzpicture}%
      % setup bounding box
      \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@paper@height);
      \ifthenelse{\equal{\kit@sectionpage@includeimage}{}} {
        \fill[KITsectionpagecolor] (0,0) rectangle (\kit@paper@width,\kit@paper@height);}{%
        \fill[KITsectionpagecolor] (0,0) rectangle (\kit@paper@width,\kit@sectionpage@image@lowery);%
      }
    \end{tikzpicture}%
  }%
  \setbeamertemplate{navigation symbols}{}%
  \setbeamertemplate{footline}{%
    \begin{tikzpicture}
      \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@footer@height);
      \ifthenelse{\equal{\kit@sectionpage@logo}{none}}{%
        \node[inner sep=0pt,outer sep=0pt,anchor=south east] at (\kit@footer@unilogo@lowerrightx,\kit@footer@unilogo@lowerrighty){};%
      }{%
        \node[inner sep=0pt,outer sep=0pt,anchor=south east] at (\kit@footer@unilogo@lowerrightx,\kit@footer@unilogo@lowerrighty)%
          {\href{https://www.kit.edu}{\includegraphics[width=\kit@footer@unilogo@width]{\kit@sectionpage@unilogo@file}}};%
      }%
    \end{tikzpicture}%
  }%
  \frame{\sectionpage}%
  \endgroup
}

%% KITsectionname
\DeclareDocumentCommand \KITsectionname { m } {%
  \renewcommand{\kit@sectionpage@intro}{#1}
}

%% KITpartpage
\define@key{partpage}{background}[KITbluegreen]{\colorlet{KITpartpagecolor}{#1}}
\define@key{partpage}{textcolor}[KITparttitledefault]{\renewcommand{\kit@partpage@textcolor}{#1}}
\presetkeys{partpage}{background=KITbluegreen,textcolor=KITparttitledefault}{}

\DeclareDocumentCommand \KITpartpage { o } {%
  \colorlet{KITpartpagecolor}{KITbluegreen}
  \renewcommand{\kit@partpage@textcolor}{KITparttitledefault}
  \IfValueTF {#1} {\setkeys{partpage}{#1}}{\setkeys{partpage}{}}
  \begingroup
  \setbeamertemplate{background}{%
    \begin{tikzpicture}%
      % setup bounding box
      \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@paper@height);
      \fill[KITpartpagecolor] (0,0) rectangle (\kit@paper@width,0.5\kit@paper@height);%
    \end{tikzpicture}%
  }%
  \setbeamertemplate{navigation symbols}{}%
  \setbeamertemplate{footline}{%
    \begin{tikzpicture}
      \useasboundingbox (0,0) rectangle (\kit@paper@width,\kit@footer@height);
      \ifthenelse{\equal{\kit@titlepage@unilogo@file}{\@empty}}{}{%
           \node[inner sep=0pt,outer sep=0pt] (unilogo) at (\kit@titlepage@unilogo@centerx,\kit@titlepage@unilogo@centery)%
           {\includegraphics[width=\kit@titlepage@unilogo@width]{corefig/kitlogo_color}};
      }%
%       \ifthenelse{\equal{\kit@sectionpage@logo}{none}}{%
%         \node[inner sep=0pt,outer sep=0pt,anchor=south east] at (\kit@footer@unilogo@lowerrightx,\kit@footer@unilogo@lowerrighty){};%
%       }{%
%         \node[inner sep=0pt,outer sep=0pt,anchor=south east] at (\kit@footer@unilogo@lowerrightx,\kit@footer@unilogo@lowerrighty)%
%           {\href{https://www.kit.edu}{\includegraphics[width=\kit@footer@unilogo@width]{corefig/kitlogo_white}}};%
%       }%
    \end{tikzpicture}%
  }%
  \setbeamercolor{part name}{fg=KITpartpagecolor}
  \setbeamercolor{part title}{fg=\kit@partpage@textcolor}
  \frame{\partpage}%
  \endgroup
}

%% KITpartname
\DeclareDocumentCommand \KITpartname { m } {%
  \renewcommand{\kit@partpage@intro}{#1}
}

%% Customized block environments
\newenvironment<>{bluegreenblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITbluegreen}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITbluegreen15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{darkbluegreenblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITdarkbluegreen}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITdarkbluegreen15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{lightblueblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITlightblue}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITlightblue15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{blueblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITblue}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITblue15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{greenblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITgreen}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITgreen15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{lightgreenblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITlightgreen}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITlightgreen15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{blackblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITblack}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITblack15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{purpleblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITpurple}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITpurple15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{orangeblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITorange}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITorange15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}
\newenvironment<>{goldblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITorange}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITorange15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{yellowblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITdarkblue,bg=KITyellow}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITyellow15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{redblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITred}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITred15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{brownblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITbrown}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITbrown15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{darkblueblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITdarkblue}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITdarkblue15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{grayblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITwhite,bg=KITgray}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITgray15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

\newenvironment<>{lightgrayblock}[1]{%
  \begin{actionenv}#2%
    \def\insertblocktitle{#1}\par%
    \setbeamercolor{block title}{fg=KITdarkblue,bg=KITlightgray}%
    \setbeamercolor{block body}{fg=KITdarkblue,bg=KITlightgray15}%
    \usebeamertemplate{block begin}
  }{\par\usebeamertemplate{block end}\end{actionenv}}

%%%%%%%%%%%%%%%%%%%%%
%% AtBeginDocument %%
%%%%%%%%%%%%%%%%%%%%%

%% parse navigation symbols
\AtBeginDocument{
  \normalsize%
  \def\kit@ins@nav#1{%
    \if#1!\let\@next=\relax\else
    \if#1s\hbox{\insertslidenavigationsymbol}%
    \let\@next=\kit@ins@nav\else
    \if#1f\hbox{\insertframenavigationsymbol}%
    \let\@next=\kit@ins@nav\else
    \if#1H\hbox{\insertsectionnavigationsymbol}%
    \let\@next=\kit@ins@nav\else
    \if#1h\hbox{\insertsubsectionnavigationsymbol}%
    \let\@next=\kit@ins@nav\else
    \if#1d\hbox{\insertdocnavigationsymbol}%
    \let\@next=\kit@ins@nav\else
    \if#1b\hbox{\insertbackfindforwardnavigationsymbol}%
    \let\@next=\kit@ins@nav\else%
    \PackageWarning{beamerKIT}{Invalid navigation symbol key `#1' has been ignored}%
    \message{To avoid the warning use only keys^^J
      \@spaces `s' to insert the slide navigation symbol^^J
      \@spaces `f' to insert the frame navigation symbol^^J
      \@spaces `H' to insert the section navigation symbol^^J
      \@spaces `h' to insert the subsection navigation symbol^^J
      \@spaces `d' to insert the doc navigation symbol and^^J
      \@spaces `b' to insert the backward - find - forward symbols.^^J}%
    \let\@next=\kit@ins@nav%
    \fi\fi\fi\fi\fi\fi\fi%
    \@next%
  }%
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% patching original beamer commands %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% avoid wobbling text when using plain frames: known issue with \nointerlineskip in plain mode
\renewenvironment{beamer@frameslide}{%
  \ifbeamer@autobreak\else%
    \ifx\beamer@againname\@empty%
      {\let\@elt\beamer@restorecounter\beamer@overlaycounterresets}%
    \else%
      {\let\@elt\beamer@labelrestorecounter\beamer@overlaycounterresets}%
    \fi%
  \fi%
  \global\c@beamerpauses=1\relax%
  \expandafter\ifblank\expandafter{\beamer@framestartpage}{%
    \stepcounter{subsectionslide}%
    \xdef\beamer@framestartpage{\the\c@page}% only first time
  }{\clearpage\beamer@notesactions}% cleanup from previous slide
  \hypersetup{pdfpagetransition=R}%
  \hypersetup{pdfpageduration=}%
  \@ifundefined{thispdfpagelabel}{}{%
  \thispdfpagelabel{\insertframenumber}}%
  \xdef\beamer@frameendpage{\the\c@page}% every time
  \xdef\beamer@slidenumber{\the\numexpr\c@page-\beamer@framestartpage+1\relax}%
  \xdef\beamer@overlaynumber{\the\beamer@slideinframe}%
  \beamer@setuplinks%
  \beamer@displaybreak%
  \global\setbox\beamer@zoombox=\box\voidb@x%
  \def\beamer@zoomer{}%
  \beamer@slidehaszoomfalse%
  \gdef\insertframetitle{}%
  \gdef\insertframesubtitle{}%
  \gdef\beamer@frametitle{}%
  \gdef\beamer@shortframetitle{}%
  \gdef\beamer@framesubtitle{}%
  \let\beamer@startcomment=\beamer@startcommentinframe%
  % Start slide:
  \beamer@framenotesbegin%
    \global\setbox\beamer@framebox=\vbox\bgroup%
    \beamer@inframetrue%
    \let\frame=\framelatex% inside frames, use LaTeX's \frame command
    \begin{beamer@framepauses}%
      \refcounter{framenumber}%use frame number for  \label
      \ifbeamer@shrink%
        \hsize=\beamer@shrinkfactorinv\hsize%
        \textwidth=\beamer@shrinkfactorinv\textwidth%
        \linewidth=\beamer@shrinkfactorinv\linewidth%
      \fi%
      % Insert labels if necessary:
      \ifx\beamer@againname\@empty\else%
        \nointerlineskip\vbox to0pt{\vss%
        \label<\the\beamer@slideinframe>{\beamer@againname<\the\beamer@slideinframe>}%
        \ifnum\beamer@slideinframe=1\relax%
          \label<1>{\beamer@againname}%
        \fi%
        }\nointerlineskip%
      \fi%
      \ifx\beamer@framehypertargets\@empty\else%
        \nointerlineskip\vbox to0pt{\vss%
          \beamer@framehypertargets%
          \global\let\beamer@framehypertargets\@empty%
        }\nointerlineskip%
      \fi%
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      %\vskip-\parskip\vbox{}%
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      %\ifbeamer@plainframe\nointerlineskip\fi%
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    \beamer@checkframetitle}%
    {\par%
    \end{beamer@framepauses}%
  \egroup%
  \ifx\beamer@frametitle\@empty%
    \setbox\beamer@frametitlebox=\box\voidb@x%
  \else%
    \setbox\beamer@frametitlebox=\vbox{%
      \vbox{}%
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      {\parskip0pt\usebeamertemplate***{frametitle}\vskip0.25em}
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    }%
  \fi%
  \ifbeamer@plainframe%
    \beamer@frametextheight=\paperheight%
  \else%
    \beamer@frametextheight=\textheight%
  \fi%
  \advance\beamer@frametextheight by-\ht\beamer@frametitlebox%
  \advance\beamer@frametextheight by-\dp\beamer@frametitlebox%
  \advance\beamer@frametextheight by-\beamer@frametopskip%
  \ifbeamer@shrink%
    \beamer@shrinkframebox%
  \fi%
  \ifx\beamer@zoomer\@empty%
    \setbox\beamer@framebox=\vbox{%
      \nobreak\vbox{}\nobreak\par\nobreak\beamer@entrycode\nobreak%
      \nointerlineskip\unvbox\beamer@frametitlebox%
      %                       ^^^^^^^^^^^^^^^^^^^^actual title and subtitle
      \nobreak%
      \ifbeamer@autobreak%
        \vskip\beamer@frametopskipautobreak%
      \else%
        \vskip\beamer@frametopskip%
      \fi%
      \nobreak%
      \nointerlineskip\box\beamer@zoombox\nointerlineskip%
      \nobreak%
      \ifbeamer@slidehaszoom\box\beamer@framebox\else\unvbox\beamer@framebox\fi%
      %                                                      ^^^^^^^^^^^^^^^actual text body
      % bottom skip is added in autobreakframebox
    }%
    \beamer@autobreakframebox%
  \else%
    \beamer@zoomer%
  \fi%
  \beamer@undolabels%
  \beamer@framenotesend%
  \box\beamer@framebox%
}

%% redefine frametopskip to always start text area at same absolute vertical position
\define@key{beamerframe}{t}[true]{% top
  \beamer@frametopskip=0pt plus .5\paperheight\relax%
  \beamer@framebottomskip=0pt plus 1fill\relax%
  \beamer@frametopskipautobreak=\beamer@frametopskip\relax%
  \beamer@framebottomskipautobreak=\beamer@framebottomskip\relax%
}

\AtBeginPart{%
  \beamer@tocsectionnumber=0\relax%
  \setcounter{section}{0}%
  \addtocontents{toc}{\protect\beamer@partintoc{\the\c@part}{\beamer@partnameshort}{\the\c@page}}%
}
\providecommand\beamer@partintoc[3]{%
  \ifnum\c@tocdepth=-1\relax
  % requesting onlyparts
  \makebox[6em]{Part #1:} #2\par\fi
}
\define@key{beamertoc}{onlyparts}[]{\c@tocdepth=-1\relax}

\AfterEndEnvironment{frame}{\restoregeometry}
